
_G.love = require("love")
_G.game = love

local fonts = {
    font1 = love.graphics.newFont(32)
}

_G.score = 0

-- require / --
    require("scripts.player")
    require("game")
    _G.Bullet = require("scripts.bullet")
    _G.enemy  = require "scripts.Enemy"
-- require \ --

_G.bullets = {}
_G.enemies = {}

local keyTimer = 0
local KeyTimerLimit = 0.3

_G.enemyTimer = 0
_G.enemyTimerMax = 4

function game.load()
    love.window.setTitle("Shooter")
    love.window.setMode(1000, 600)
    player.load()

    _G.backg = game.graphics.newImage("assets/images/background.png")
end

function game.update(dt)
    player.update(dt)

    enemyTimer = enemyTimer + dt


    if enemyTimer > enemyTimerMax then
        local _x = love.graphics.getWidth() - 100
        local _y = math.random(50,500 )

        table.insert(enemies, 1, Enemy(_x, _y))

        enemyTimer = 0
    end

   -- for e = 1, #enemies do
 
   -- end

    game_logic(dt)

    if love.keyboard.isDown(controls["shoot"]) then
        keyTimer = keyTimer + 1 * dt
        if keyTimer > KeyTimerLimit then
            keyTimer = 0
            shoot()
        end
    end
end


function game.draw()
    love.graphics.draw(backg, 0, 0, nil, 2.5)
    love.graphics.setBackgroundColor(1, 1, 1)
    player.draw()

    for i = 1, #bullets do
        local bullet = bullets[i]
        bullet:draw()
    end

    for i = 1, #enemies do
        enemies[i]:draw()
    end

    love.graphics.setFont(fonts.font1)
    love.graphics.print(score, 15, 10)
end

function love.keyboardpressed(key)
    if key == "space" then
        shoot()
    end   
end

_G.shoot = function() table.insert(bullets, 1, Bullet()) end
